=== modified file 'Makefile'
--- Makefile	2010-10-02 17:23:41 +0000
+++ Makefile	2010-10-11 17:45:21 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.2.1
+version=1.2.3
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2010-10-02 17:23:41 +0000
+++ NEWS	2010-10-11 17:45:21 +0000
@@ -1,6 +1,14 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.2.3 (2010-10-11)
+* Server:
+** Bug fix: Expose D-Bus API also in non-debug mode.
+
+Version 1.2.2 (2010-10-07)
+* Client:
+** splashy: Minor fix to compile with non-Linux kernels.
+
 Version 1.2.1 (2010-10-02)
 * Server:
 ** mandos-monitor(8): Documentation bug fix: Key for removing client

=== modified file 'TODO'
--- TODO	2010-09-26 18:32:58 +0000
+++ TODO	2010-11-16 17:58:49 +0000
@@ -2,6 +2,8 @@
 
 * Use _attribute_((nonnull)) wherever possible.
 
+* mandos-applet
+
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name

=== modified file 'common.ent'
--- common.ent	2010-10-02 17:23:41 +0000
+++ common.ent	2010-10-11 17:45:21 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.1">
+<!ENTITY version "1.2.3">

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-02 17:53:34 +0000
+++ debian/changelog	2010-10-11 17:45:21 +0000
@@ -1,3 +1,22 @@
+mandos (1.2.3-1) experimental; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Mon, 11 Oct 2010 19:37:31 +0200
+
+mandos (1.2.2-1) experimental; urgency=low
+
+  * New upstream release.
+  * plugins.d/splashy.c: Only use ELIBBAD if defined. (Closes: #599256)
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 07 Oct 2010 20:27:54 +0200
+
+mandos (1.2.1-3) experimental; urgency=low
+
+  * debian/changelog: Include entry for NMU of version 1.0.14-1.1.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 05 Oct 2010 20:58:38 +0200
+
 mandos (1.2.1-2) unstable; urgency=low
 
   * debian/source/format: New; contains "3.0 (quilt)".  Really.
@@ -30,6 +49,13 @@
 
  -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 28 Sep 2010 20:46:11 +0200
 
+mandos (1.0.14-1.1) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Rebuild against libavahi-core-dev (>= 0.6.26-1).
+
+ -- Michael Biebl <biebl@debian.org>  Mon, 12 Jul 2010 16:34:34 +0200
+
 mandos (1.0.14-1) unstable; urgency=low (HIGH on mips and mipsel)
 
   * New upstream release.

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2009-01-18 06:41:57 +0000
+++ debian/mandos-client.lintian-overrides	2010-10-13 06:12:52 +0000
@@ -19,6 +19,7 @@
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/plymouth 4755 root/root
 
 # The directory /etc/mandos/plugins.d can be used by local system
 # administrators to place plugins in, overriding and complementing

=== modified file 'mandos'
--- mandos	2010-10-02 17:23:41 +0000
+++ mandos	2010-10-13 17:33:08 +0000
@@ -81,7 +81,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.2.1"
+version = "1.2.3"
 
 #logger = logging.getLogger(u'mandos')
 logger = logging.Logger(u'mandos')
@@ -204,7 +204,7 @@
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
             logger.debug(u"Zeroconf service established.")
         elif state == avahi.ENTRY_GROUP_COLLISION:
-            logger.warning(u"Zeroconf service name collision.")
+            logger.info(u"Zeroconf service name collision.")
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical(u"Avahi: Error in group state changed %s",
@@ -1847,6 +1847,10 @@
         # No console logging
         logger.removeHandler(console)
     
+    # Need to fork before connecting to D-Bus
+    if not debug:
+        # Close all input and output, do double fork, etc.
+        daemon()
     
     global main_loop
     # From the Avahi example code
@@ -1870,11 +1874,7 @@
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings[u"interface"])))
-
-    if not debug:
-        # Close all input and output, do double fork, etc.
-        daemon()
-        
+    
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
     

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-02 17:23:41 +0000
+++ mandos-ctl	2010-10-11 17:45:21 +0000
@@ -57,7 +57,7 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
+version = "1.2.3"
 
 def timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta object to milliseconds"

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-02 17:23:41 +0000
+++ mandos-keygen	2010-10-11 17:45:21 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.2.1"
+VERSION="1.2.3"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-10-02 17:23:41 +0000
+++ mandos-monitor	2010-10-11 17:45:21 +0000
@@ -51,7 +51,7 @@
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
+version = "1.2.3"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-02 17:23:41 +0000
+++ mandos.lsm	2010-10-11 17:45:21 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.2.1
-Entered-date:	2010-10-02
+Version:	1.2.3
+Entered-date:	2010-10-11
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      130K mandos_1.2.1.orig.tar.gz
+	      133K mandos_1.2.3.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		130K mandos_1.2.1.orig.tar.gz
+		133K mandos_1.2.3.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-11-05 18:30:07 +0000
+++ plugins.d/password-prompt.c	2010-09-26 18:32:58 +0000
@@ -22,23 +22,22 @@
  * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
-#define _GNU_SOURCE		/* getline(), asprintf() */
+#define _GNU_SOURCE		/* getline() */
 
 #include <termios.h> 		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO, readlink() */
+				   tcgetattr(), ECHO */
 #include <signal.h>		/* sig_atomic_t, raise(), struct
 				   sigaction, sigemptyset(),
 				   sigaction(), sigaddset(), SIGINT,
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t, struct dirent, pid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getenv(), free() */
-#include <dirent.h>		/* scandir(), alphasort() */
+				   getenv() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
 				   stdin, feof(), fputc()
 				*/
@@ -48,9 +47,7 @@
 #include <error.h>		/* error() */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <inttypes.h>		/* strtoumax() */
-#include <sys/stat.h> 		/* struct stat, lstat() */
-#include <string.h> 		/* strlen, rindex, memcmp */
+#include <string.h> 		/* strlen, rindex */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -65,10 +62,6 @@
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
-/* Needed for conflic resolution */
-const char plymouthd_path[] = "/sbin/plymouth";
-
-
 static void termination_handler(int signum){
   if(quit_now){
     return;
@@ -77,74 +70,6 @@
   signal_received = signum;
 }
 
-bool conflict_detection(void){
-
-  /* plymouth conflicts with password-promt since both want to control the
-     associated terminal. Password-prompt exit since plymouth perferms the same
-     functionallity.
-   */
-  int is_plymouth(const struct dirent *proc_entry){
-    int ret;
-    {
-      uintmax_t maxvalue;
-      char *tmp;
-      errno = 0;
-      maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
-      
-      if(errno != 0 or *tmp != '\0'
-	 or maxvalue != (uintmax_t)((pid_t)maxvalue)){
-	return 0;
-      }
-    }
-    char exe_target[sizeof(plymouthd_path)];
-    char *exe_link;
-    ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
-    if(ret == -1){
-      error(0, errno, "asprintf");
-      return 0;
-    }
-  
-    struct stat exe_stat;
-    ret = lstat(exe_link, &exe_stat);
-    if(ret == -1){
-      free(exe_link);
-      if(errno != ENOENT){
-	error(0, errno, "lstat");
-      }
-      return 0;
-    }
-  
-    if(not S_ISLNK(exe_stat.st_mode)
-       or exe_stat.st_uid != 0
-       or exe_stat.st_gid != 0){
-      free(exe_link);
-      return 0;
-    }
-  
-    ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
-    free(exe_link);
-    if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-       (memcmp(plymouthd_path, exe_target,
-	       sizeof(plymouthd_path)-1) != 0)){
-      return 0;
-    }
-    return 1;
-  }
-
-  struct dirent **direntries;
-  int ret;
-  ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-  if (ret == -1){
-    error(1, errno, "scandir");
-  }
-  if (ret < 0){
-    return 1;
-  } else {
-    return 0;
-  }
-}
-
-
 int main(int argc, char **argv){
   ssize_t sret;
   int ret;
@@ -226,14 +151,6 @@
   if(debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
-
-  if (conflict_detection()){
-    if(debug){
-      fprintf(stderr, "Stopping %s because of conflict", argv[0]);
-    }
-    return EXIT_FAILURE;
-  }
-  
   if(debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-11-05 18:30:07 +0000
+++ plugins.d/plymouth.c	2010-11-16 17:58:49 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Usplash - Read a password from usplash and output it
+ * Plymouth - Read a password from Plymouth and output it
  * 
  * Copyright © 2010 Teddy Hogeborn
  * Copyright © 2010 Björn Påhlsson
@@ -76,21 +76,23 @@
   char *prompt;
   const char *const cryptsource = getenv("cryptsource");
   const char *const crypttarget = getenv("crypttarget");
-  const char prompt_start[] = "Enter passphrase to unlock the disk";
+  const char prompt_start[] = "Unlocking the disk";
+  const char prompt_end[] = "Enter passphrase";
   
   if(cryptsource == NULL){
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s: ", prompt_start);
+      ret = asprintf(&prompt, "%s\n%s", prompt_start, prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s (%s): ", prompt_start,
-		     crypttarget);
+      ret = asprintf(&prompt, "%s (%s)\n%s", prompt_start,
+		     crypttarget, prompt_end);
     }
   } else {
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
+      ret = asprintf(&prompt, "%s %s\n%s", prompt_start, cryptsource,
+		     prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
-		     cryptsource, crypttarget);
+      ret = asprintf(&prompt, "%s %s (%s)\n%s", prompt_start,
+		     cryptsource, crypttarget, prompt_end);
     }
   }
   if(ret == -1){
@@ -142,21 +144,21 @@
 	_exit(EX_OSERR);
       }
     }
-
+    
     char **new_argv = NULL;
-    char *tmp;
+    char **tmp;
     int i = 0;
-    for (; argv[i]!=(char *)NULL; i++){
+    for (; argv[i]!=NULL; i++){
       tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
       if (tmp == NULL){
 	error(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
       }
-      new_argv = (char **)tmp;
+      new_argv = tmp;
       new_argv[i] = strdup(argv[i]);
     }
-    new_argv[i] = (char *) NULL;
+    new_argv[i] = NULL;
     
     execv(path, (char *const *)new_argv);
     error(0, errno, "execv");
@@ -196,7 +198,7 @@
       return 0;
     }
   }
-  char exe_target[sizeof(plymouthd_path)];
+  char exe_target[sizeof(plymouth_path)];
   char *exe_link;
   ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
   if(ret == -1){
@@ -223,9 +225,9 @@
   
   ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
   free(exe_link);
-  if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-      (memcmp(plymouthd_path, exe_target,
-	      sizeof(plymouthd_path)-1) != 0)){
+  if((sret != (ssize_t)sizeof(plymouth_path)-1) or
+      (memcmp(plymouth_path, exe_target,
+	      sizeof(plymouth_path)-1) != 0)){
     return 0;
   }
   return 1;
@@ -245,15 +247,7 @@
   if(maxvalue == 0){
     struct dirent **direntries;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    if (ret == -1){
-      error(0, errno, "scandir");
-    }
-    if (ret > 0){
-      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
-      if (ret < 0){
-	error(0, errno, "sscanf");
-      }
-    }
+    sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
   }
   pid_t pid;
   pid = (pid_t)maxvalue;

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-09-26 18:32:58 +0000
+++ plugins.d/splashy.c	2010-10-07 17:46:56 +0000
@@ -314,7 +314,9 @@
       case ENOTDIR:
       case ELOOP:
       case EISDIR:
-      case ELIBBAD:
+#ifdef ELIBBAD
+      case ELIBBAD:		/* Linux only */
+#endif
       case EPERM:
 	_exit(EX_OSFILE);
       }

